Attribute VB_Name = "modRevisioner"
Option Explicit

Private Const mShowDebugMessage = False

Public Function getSelectedVersionPath() As String
    getSelectedVersionPath = frmMain.lstVersions.SelectedItem.Tag
End Function

Public Function getPathFrom() As String
    Dim pathFrom As String
    
    pathFrom = frmMain.txtPathSourceRoot.text & "\" & getPathRelativeProject
    
    getPathFrom = pathFrom
End Function

Public Function getPathTo() As String
    Dim pathTo As String
    
    pathTo = frmMain.txtPathRevisionRoot.text & "\" & getPathRelativeProject
    
    getPathTo = pathTo
End Function

Public Function getPathToRevisionProject() As String
    Dim pathToRevisionProject As String
    
    pathToRevisionProject = getPathTo & "\" & frmMain.txtPathRevision.text
    
    getPathToRevisionProject = pathToRevisionProject
End Function

Private Function getPathRelativeProject() As String
    Dim pathRelative As String
    
    pathRelative = Mid$(frmMain.txtPathSource.text, _
            Len(frmMain.txtPathSourceRoot.text) + Len("\") + 1)
    
    getPathRelativeProject = pathRelative
End Function

Public Function doCreateFolder(ByVal pathFolder As String) As Boolean
    Dim success As Boolean
    
    success = True
    On Error GoTo doCreateFolderError
    MkDir pathFolder
    If mShowDebugMessage Then
        MsgBox "Creating folder: " & pathFolder
    End If
            
    GoTo doCreateFolderContinue
doCreateFolderError:
    success = False
    
doCreateFolderContinue:
    On Error GoTo 0

    doCreateFolder = success
End Function

Public Function doCopyFile(ByVal pathFrom As String, ByVal pathTo As String) As Boolean
    Dim success As Boolean
    
    success = True
    On Error GoTo doCopyFileError
    FileCopy pathFrom, pathTo
    If mShowDebugMessage Then
        MsgBox "Copy From: " & pathFrom & vbNewLine & "Copy To: " & pathTo
    End If
    
    GoTo doCopyFileContinue
doCopyFileError:
    success = False
    
doCopyFileContinue:
    On Error GoTo 0

    doCopyFile = success
End Function

Public Function getLatestBackupFolder() As String
    getLatestBackupFolder = frmMain.lstVersions.ListItems.item(1).Tag
End Function
